Index: /palm/trunk/UTIL/inifor/Makefile
===================================================================
--- /palm/trunk/UTIL/inifor/Makefile	(revision 3394)
+++ /palm/trunk/UTIL/inifor/Makefile	(revision 3395)
@@ -25,4 +25,7 @@
 # -----------------
 # $Id$
+# Updated build order
+# 
+# 3183 2018-07-27 14:25:55Z suehring
 # Added __netcdf4 preprocessor flag
 # 
@@ -47,5 +50,5 @@
 TEST_PATH = $(PROJECT_PATH)/tests
 
-MODULES = $(SRC_PATH)/defs.mod $(SRC_PATH)/util.mod $(SRC_PATH)/control.mod $(SRC_PATH)/types.mod $(SRC_PATH)/transform.mod $(SRC_PATH)/io.mod $(SRC_PATH)/grid.mod
+MODULES = $(SRC_PATH)/defs.mod $(SRC_PATH)/types.mod $(SRC_PATH)/util.mod $(SRC_PATH)/control.mod $(SRC_PATH)/transform.mod $(SRC_PATH)/io.mod $(SRC_PATH)/grid.mod
 SOURCES = $(MODULES:%.mod=%.f90) $(SRC_PATH)/$(PROJECT).f90
 OBJECTS = $(SOURCES:%.f90=%.o)
Index: /palm/trunk/UTIL/inifor/Makefile.gnu
===================================================================
--- /palm/trunk/UTIL/inifor/Makefile.gnu	(revision 3394)
+++ /palm/trunk/UTIL/inifor/Makefile.gnu	(revision 3395)
@@ -25,4 +25,7 @@
 # -----------------
 # $Id$
+# Updated build order
+# 
+# 3183 2018-07-27 14:25:55Z suehring
 # Added __netcdf4 preprocessor flag
 # Corrected compilation order
@@ -44,9 +47,9 @@
 PROJECT = inifor
 PROJECT_PATH = .
-BIN_PATH  = $(PROJECT_PATH)/bin
+BIN_PATH  = $(PROJECT_PATH)/../../SCRIPTS
 SRC_PATH  = $(PROJECT_PATH)/src
 TEST_PATH = $(PROJECT_PATH)/tests
 
-MODULES = $(SRC_PATH)/defs.mod $(SRC_PATH)/util.mod $(SRC_PATH)/control.mod $(SRC_PATH)/types.mod $(SRC_PATH)/transform.mod $(SRC_PATH)/io.mod $(SRC_PATH)/grid.mod
+MODULES = $(SRC_PATH)/defs.mod $(SRC_PATH)/types.mod $(SRC_PATH)/util.mod $(SRC_PATH)/control.mod $(SRC_PATH)/transform.mod $(SRC_PATH)/io.mod $(SRC_PATH)/grid.mod
 SOURCES = $(MODULES:%.mod=%.f90) $(SRC_PATH)/$(PROJECT).f90
 OBJECTS = $(SOURCES:%.f90=%.o)
Index: /palm/trunk/UTIL/inifor/Makefile.ifort
===================================================================
--- /palm/trunk/UTIL/inifor/Makefile.ifort	(revision 3394)
+++ /palm/trunk/UTIL/inifor/Makefile.ifort	(revision 3395)
@@ -25,4 +25,7 @@
 # -----------------
 # $Id$
+# Updated build order
+# 
+# 3183 2018-07-27 14:25:55Z suehring
 # Added __netcdf4 preprocessor flag
 # Corrected compilation order
@@ -44,9 +47,9 @@
 PROJECT = inifor
 PROJECT_PATH = .
-BIN_PATH  = $(PROJECT_PATH)/bin
+BIN_PATH  = $(PROJECT_PATH)/../../SCRIPTS
 SRC_PATH  = $(PROJECT_PATH)/src
 TEST_PATH = $(PROJECT_PATH)/tests
 
-MODULES = $(SRC_PATH)/defs.mod $(SRC_PATH)/util.mod $(SRC_PATH)/control.mod $(SRC_PATH)/types.mod $(SRC_PATH)/transform.mod $(SRC_PATH)/io.mod $(SRC_PATH)/grid.mod
+MODULES = $(SRC_PATH)/defs.mod $(SRC_PATH)/types.mod $(SRC_PATH)/util.mod $(SRC_PATH)/control.mod $(SRC_PATH)/transform.mod $(SRC_PATH)/io.mod $(SRC_PATH)/grid.mod
 SOURCES = $(MODULES:%.mod=%.f90) $(SRC_PATH)/$(PROJECT).f90
 OBJECTS = $(SOURCES:%.f90=%.o)
Index: /palm/trunk/UTIL/inifor/README
===================================================================
--- /palm/trunk/UTIL/inifor/README	(revision 3394)
+++ /palm/trunk/UTIL/inifor/README	(revision 3395)
@@ -1,3 +1,3 @@
-# INIFOR - Mesoscale Interface for Initializing and Forcing PALM-4U (v1.3.0)
+# INIFOR - Mesoscale Interface for Initializing and Forcing PALM-4U (v1.4.0)
 
 INIFOR provides the meteorological fields required to initialize and drive the
@@ -14,11 +14,55 @@
 
 
+## MINIMAL USAGE EXAMPLE
+
+1. Customize `./namelist` (number of grid points and spacings, end_time)
+2. Run `current_version/trunk/SCRIPTS/inifor --path <scenario path> --date <YYYYMMDD>`
+
+
 ## USAGE
 
-1. Customize `./namelist` (number or grid points and spacings, end_time)
-2. Run `current_version/trunk/SCRIPTS/inifor -path <scenario path> -date <YYYYMMDD>`
+After compilation, the `inifor` binary resides in the `$PALM_BIN` path, i.e. in
+`<PALM path>/current_version/trunk/SCRIPTS/`.
+
+In order to run, INIFOR requires three kinds of inputs:
+
+1. hourly COSMO model output,
+2. a steering namelist file, and
+3. command-line options.
+
+In addition, a static driver file may be supplied (see `--static-driver` option
+below) in order to pass the coordinates of the PALM origin to INIFOR. If no
+static driver is passed to INIFOR, origin coordinates are read from the namelist
+file.
+
+A typical `inifor` call looks like this:
+
+    inifor --path /data/evaluation/20170729 --date 2017073006 \
+           --init-mode profile -n namelist -o dynamic_driver.nc \
+           --elevation 110 --input-prefix lff0
+
+### INPUT DATA: COSMO MODEL OUTPUT
+
+INIFOR processes COSMO model output which it requires to be stored in a set of
+netCDF files located in a user-specified path (see `--path` option). These are:
+
+- hhl.nc: This file provides the COSMO numerical grid. (*hhl* abbreviates
+  *height of half layers*, i.e. the heights of the vertical cell boundaries.)
+- soil.nc: This file provides the COSMO soil map and is used to destinguish land
+  from water cells.
+- `<prefix>YYYYMMDDHH-<suffix>.nc`: Each of these files contains COSMO model
+  of one time step at the given time in UTC (Y..year, M..month, D..day, H..hour).
+    - The `<prefix>` distinguishes different DWD products, for instance COSMO
+      analyses (`laf`) or forecasts (`lff`).
+    - The `<suffix>` distinguishes four kinds of COSMO model output data, namely
+        - `flow` (atmospheric fields)
+        - `rad` (radiation)
+        - `soil` (soil moisture and temperature)
+        - `soilmoisture` (precipitation and evaporation)
+    - For example, laf2016010100-flow.nc contains the atmospheric fields of the
+      COSMO analysis of Januray 1st, 2016 for 0:00 UTC.
 
 
-## AVAILABLE NAMELIST PARAMETERS
+### AVAILABLE NAMELIST PARAMETERS
 
 INIFOR mirrors a subset of the PALM-4U's Fortran namelists `inipar` and `d3par`
@@ -26,5 +70,5 @@
 
 
-### inipar
+#### inipar
 
     nx, ny, nz - number of PALM-4U grid points in x, y, and z direction
@@ -34,11 +78,11 @@
     dz_max - maximum vertical grid spacing [m]
     dz_stretch_level_start(9) - array of height levels above which the grid is
-    to be stretched vertically [m]
+        to be stretched vertically [m]
     dz_stretch_level_end(9) - array of height levels until which the grid is to
-    be stretched vertically [m]
+        be stretched vertically [m]
     longitude, latitude - geographical coordinates of the PALM-4U origin [deg]
 
 
-### d3par
+#### d3par
 
     end_time - PALM-4U simulation time. INIFOR will produce hourly forcing data
@@ -47,5 +91,5 @@
 
 
-### EXAMPLE NAMELIST FILE
+#### EXAMPLE NAMELIST FILE
 
     &inipar nx = 4679, ny = 3939, nz = 360
@@ -59,5 +103,13 @@
 
 
-## AVAILABLE COMMAND-LINE PARAMETERS
+### AVAILABLE COMMAND-LINE PARAMETERS
+    --averaging-mode <mode>:
+        Selects how averaged quantities (large-scale forcing terms) are computed.
+        INIFOR supports averaging along input model levels ('level') and along
+        constant heights ('height'). Default: level
+
+    -a, --averaging-angle <angle>:
+        Width of the averaging box in longitudal and latitudal direction in the
+        source coordinate system (COSMO rotated-pole) [deg]. Default: 2.0
 
     -d, --date, -date <date>:
@@ -65,5 +117,5 @@
         hours (HH) are given, INIFOR assumes that the simulation starts at O UTC
         on that day. Default: 20130721
-        
+
     -i, --init-mode, -mode <mode>:
         Set the PALM-4U initialization mode. INIFOR can provide initial conditions
@@ -72,5 +124,5 @@
 
     -l, --hhl-file, -hhl <netCDF file>:
-        Location of the netCDF file containing the vertical COSMO-DE grid levels,
+        Location of the netCDF file containing the vertical COSMO grid levels,
         specifically the heights of half levels (hhl, i.e. vertical cell faces).
         Default: <scenario path>/hhl.nc
@@ -83,5 +135,5 @@
     -o, --output <output file>:
         Name of the INIFOR output file, i.e. the PALM-4U dynamic driver.
-        Default: ./palm-4u-input.nc
+        Default: ./dynamic_driver.nc
 
     -p, --path, -path <scenario path>:
@@ -89,23 +141,22 @@
 
     -r, --surface-pressure, -p0 <pressure>:
-        Surface pressure at z=0 in the PALM-4U domain [Pa].
-        Default: 1e5
+        Manually set the pressure at z=0 in the PALM-4U domain [Pa]. If not
+        given, the surface pressure is computed from the COSMO pressure field.
 
     -s, --soil-file, -soil <netCDF file>:
-        Location of the netCDF file containing the COSMO-DE soil type map.
+        Location of the netCDF file containing the COSMO soil type map.
         Default: <scenario path>/soil.nc
 
     -t, --static-driver, -static <netCDF file>:
-        Location of the netCDF file containing the static driver file for the case
+        Location of the netCDF file containing the static driver for the case
         to be simulated with PALM-4U. Optional parameter. Default: None
 
     -u, --geostrophic-u, -ug <velocity>:
-        Specifies the geostrophic wind in x direction [m/s]. Default: 0
+        Manually specify the geostrophic wind in x direction [m/s]. If not
+        given, the geostrophic wind is computed from the COSMO pressure field.
 
     -v, --geostrophic-v, -vg <velocity>:
-        Specifies the geostrophic wind in y direction [m/s]. Default: 0
-
-    --version:
-        Output version number and exit.
+        Manually specify the geostrophic wind in y direction [m/s]. If not
+        given, the geostrophic wind is computed from the COSMO pressure field.
 
     -z, --elevation, -z0 <height>: Specifies the elevation of the PALM-4U domain
@@ -113,5 +164,9 @@
 
 
-## ADDITIONAL COMMAND-LINE OPTIONS
+#### ADDITIONAL COMMAND-LINE OPTIONS
+
+    --input-prefix <prefix>:
+        Set the file prefixes for all input files. Individual prefixes can be
+        overwritten with the options below. Default: laf
 
     --flow-prefix <prefix>:
@@ -126,2 +181,9 @@
     --soilmoisture-prefix <prefix>:
         Set the file prefix of soil moisture input files. Default: laf
+
+    --debug:
+        Enable debugging messages.
+
+    --version:
+        Output version number and exit.
+
Index: /palm/trunk/UTIL/inifor/src/control.f90
===================================================================
--- /palm/trunk/UTIL/inifor/src/control.f90	(revision 3394)
+++ /palm/trunk/UTIL/inifor/src/control.f90	(revision 3395)
@@ -26,4 +26,8 @@
 ! -----------------
 ! $Id$
+! Suppress debugging messages unless --debug option is given
+! 
+!
+! 3183 2018-07-27 14:25:55Z suehring
 ! Added version and copyright output
 ! 
@@ -57,12 +61,13 @@
  CONTAINS
 
-    SUBROUTINE report(routine, message)
-
-       CHARACTER(LEN=*), INTENT(IN) ::  routine
-       CHARACTER(LEN=*), INTENT(IN) ::  message
-       INTEGER                      ::  u
-       LOGICAL, SAVE                ::  is_first_run = .TRUE.
-
-       PRINT *, "inifor: " // TRIM(message) // "  [ " // TRIM(routine) // " ]"
+    SUBROUTINE report(routine, message, debug)
+
+       CHARACTER(LEN=*), INTENT(IN)  ::  routine
+       CHARACTER(LEN=*), INTENT(IN)  ::  message
+       LOGICAL, OPTIONAL, INTENT(IN) ::  debug
+       INTEGER                       ::  u
+       LOGICAL, SAVE                 ::  is_first_run = .TRUE.
+       LOGICAL                       ::  suppress_message
+
 
        IF (is_first_run)  THEN
@@ -73,5 +78,14 @@
        END IF
           
-       WRITE(u, *)  TRIM(message) // "  [ " // TRIM(routine) // " ]"
+
+       suppress_message = .FALSE.
+       IF (PRESENT(debug))  THEN
+          IF (.NOT. debug)  suppress_message = .TRUE.
+       END IF
+
+       IF (.NOT. suppress_message)  THEN
+          PRINT *, "inifor: " // TRIM(message) // "  [ " // TRIM(routine) // " ]"
+          WRITE(u, *)  TRIM(message) // "  [ " // TRIM(routine) // " ]"
+       END IF
 
        CLOSE(u)
Index: /palm/trunk/UTIL/inifor/src/defs.f90
===================================================================
--- /palm/trunk/UTIL/inifor/src/defs.f90	(revision 3394)
+++ /palm/trunk/UTIL/inifor/src/defs.f90	(revision 3395)
@@ -26,4 +26,9 @@
 ! -----------------
 ! $Id$
+! New parameters for computation of geostrophic winds
+! Bumped INIFOR version number
+! 
+! 
+! 3183 2018-07-27 14:25:55Z suehring
 ! Updated defaults for soil extrapolation steps and nudging time-scale
 ! Improved handling of the start date string
@@ -73,6 +78,8 @@
  REAL(dp), PARAMETER ::  G    = 9.80665_dp                    !< acceleration of Earth's gravity, used in computation of COSMO-DE's basic state [m/s/s]
  REAL(dp), PARAMETER ::  RHO_L = 1e3_dp                       !< density of liquid water, used to convert W_SO from [kg/m^2] to [m^3/m^3], in [kg/m^3]
+ REAL(dp), PARAMETER ::  HECTO = 100_dp                       !< unit conversion factor from hPa to Pa
 
  ! PALM-4U parameters
+ REAL(dp), PARAMETER ::  OMEGA   = 7.29e-5_dp                 !< angular velocity of Earth's rotation [s^-1]
  REAL(dp), PARAMETER ::  P_REF   = 1e5_dp                     !< Reference pressure for potential temperature [Pa]
  REAL(dp), PARAMETER ::  RD_PALM = 287.0_dp                   !< specific gas constant of dry air, used in computation of PALM-4U's potential temperature [J/kg/K]
@@ -83,5 +90,5 @@
  INTEGER, PARAMETER          ::  FORCING_STEP = 1             !< Number of hours between forcing time steps [h]
  REAL(dp), PARAMETER         ::  NUDGING_TAU = 21600.0_dp     !< Nudging relaxation time scale [s]
- CHARACTER(LEN=*), PARAMETER ::  VERSION = '1.3.0'            !< INIFOR version number
+ CHARACTER(LEN=*), PARAMETER ::  VERSION = '1.4.0'            !< INIFOR version number
  CHARACTER(LEN=*), PARAMETER ::  COPYRIGHT = 'Copyright 2017-2018 Leibniz Universitaet Hannover' // &
      NEW_LINE(' ') // ' Copyright 2017-2018 Deutscher Wetterdienst Offenbach' !< Copyright notice
